#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <mem.h>
#include <process.h>
#include <string.h>
#include "pcxview.h"

char far *vmem=(char far*)0xA0000000L;

#define ViewX 150
#define ViewY 110
float Zoom = 0.1;
#define axisx 90
#define axisy 90
#define axisz 10

typedef struct {
  int a[8][3];
} Box3DType;

Box3DType Box3D, BoxC, Org3D;

char FONT[256][16];

#define swap(a,b) (a=a-(b=(a+=b)-b))
#define putdot(x,y,c) *(vmem+ (x-1) + (y-1)*320)=c
#define putdot2(x,y,c) *(vmem+ (x) + (y)*320)=c
#define getdot(x,y)   *(vmem+ (x-1) + (y-1)*320)
#define puttextchar(x, y, c, col)  *((unsigned far *)0xb8000000L + (x-1) + (y-1)*80) = (unsigned)((col << 8)) | (unsigned)c

void screenmode(int m);
void clearscreen(char rr);
void drawline(int x1, int y1, int x2, int y2, char col);
void drawline2(int x1, int y1, int x2, int y2, char col, int del);
void angle2dconv(int ox, int oy, int *x, int *y, float a);
void angle3dconv(int ox, int oy, int oz, int *x, int *y, int *z,
		 float a, float b, float c);
void drawcircle(int x, int y, int r, char col);
void drawcircle2(int x, int y, int r, char col, char sval, char eval, int del);
void drawcircle3(int x, int y, int r, char col, int sval, int ang, char l);
void drawcaerang();
void sparkeffect();
void snowfalls();
void gettextfont(byte code, char table[]);
void settextfont(byte code, char table[]);
long filesize(FILE *stream);
void color2bw();
void bwfilm();
void colorfilm();
void emphasize_bw();
void emphasize_color();
void gray4scale_bw();
void gray4scale_color();
void fallingdots(int del);
void polygon1();
void polygon2();
void cut4times();
void verticalwave();
void WVirt();
void drawbox(int l, int t, int r, int b, char col);
void zoom2x(int x1, int y1, int x2, int y2, int dx, int dy);
int  alarm(int sec);
void pause(int sec);
void pause2(int sec);
void drawstr(char *str, int x, int y, char col, char zx, char zy);
void drawstr2(char *str, int x, int y, char col);
void NewWriterInit();
void introstr(char *str, int x, int y, char l);
void Draw3dbox(void);
void MakeSame(int *src, int *dest);
void move3dbox();
void perspective(Box3DType *o);
void rotate(int x1, int y1, int x2, int y2, int dx, int dy);
void demo1();
void fallchar(char *c, int x);
void lastcaerang();
void noize();
void fadeout();
void findoutline();
char getrgbavr(int x, int y);
void woodcutprint();
void plasma();
int set_a(int x,int y);
void scrolluptext();
void putstr(byte *str, char x, char y, char col, char cen);
void cursor(char nf);
void clear4textpage();
void blinkattr(char bool);
void undefinable();
void electricworm();
void mosaic(int x1, int y1, int x2, int y2, char val);
void drawstar(char b);
void perspective_star();
void spacestar();

void main(int argc)
{
  blinkattr(0);
  NewWriterInit();
  screenmode(0x13);
  saveorgrgb();
  clearscreen(0);

  if (argc<2) demo1();

  lastcaerang();
  delay(2000);
  clearscreen(0);
  introstr("Is END?", 100, 80, 0);

  viewpcx("han.pcx");
  delay(3000);
  cut4times();
  clearscreen(1);
  delay(1000);

  drawstr("All routines & algorithms", 30, 10, 15, 1, 1);
  drawstr(" are made by Jinhong Kim.", 30, 25, 15, 1, 1);
  drawstr("I'll open the source to you,", 30, 50, 15, 1, 1);
  drawstr(" if you want to know.", 30, 65, 15, 1, 1);
  drawstr("I used TURBO C++ 3.0 & PASCAL 7.0", 5, 85, 15, 1, 1);
  drawstr("Thanks to the hallym univ. people!", 5, 120, 12, 1, 2);
  drawstr("PAGER #: 015-183-2575", 42, 160, 15, 1, 1);
  pause(10);
  fallingdots(0);

  clearscreen(0);
  screenmode(0x03);

  delay(1000);
  scrolluptext();
  cursor(1);
}

void demo1()
{
  int t;

  drawstr("This program is a demo to show", 10, 10, 15, 1,1);
  drawstr("technical programming with C.", 10, 30, 15, 1,1);
  drawstr("I made this for your eyes.", 10, 60, 9, 1, 2);
  drawstr("Have a good recollection!", 10, 120, 10, 1,1);
  pause(7);
  clearscreen(0);

  introstr("S T A R T",75,80, 0);
  introstr("2D GRAPHICS", 55, 80, 0);
  drawcaerang();
  pause(3);
  sparkeffect();
  fallingdots(0);

  delay(1000);
  introstr("POLYGONS",75,80, 1);
  clearscreen(0);
  delay(1000);
  polygon1();

  savergb();
  for (t=1; t<64; t++) setrgb(t, t, t, t);

  clearscreen(0);
  polygon2();
  clearscreen(0);
  restorergb();

  introstr("Vertical wave", 40, 80, 0);
  verticalwave();

  introstr("Snowfalls...", 70, 80, 1);
  snowfalls();


  savergb();
  for (t=1; t<64; t++) setrgb(t, t, t, t);

  introstr("PALETTE SCROLL", 40, 80, 1);

  for (t=1; t<=320; t++) drawline(t, 1, t, 200, (t % 63)+1);
  pause2(6);
  clearscreen(0);
  for (t=1; t<=160; t++) {
	drawline(t, 1, t, 200, (t % 63)+1);
	drawline(321-t,1, 321-t, 200, (t % 63)+1);
  }
  pause2(6);
  clearscreen(0);
  for (t=1; t<=320; t++) {
	drawline(1, 200, t, 1, (t % 63)+1);
	drawline(320, 1, 321-t, 200, (t % 63)+1);
  }
  pause2(6);
  restorergb();

  clearscreen(0);
  introstr("NoIsE", 100, 80, 0);
  noize();

  introstr("PLASMA", 100, 80, 0);
  viewpcx("plasma.pcx");
  plasma();
  clearscreen(1);

  introstr("UNDEFINABLE", 60, 80, 0);
  undefinable();
  clearscreen(0);

  introstr("ELECTRIC WORM", 50, 80, 0);
  electricworm();

  clearscreen(0);
  introstr("IMAGE PROCESSING", 20, 80, 0);
  delay(1000);

  viewpcx("flower.pcx");
  pause(3);
  drawstr("M O S A I C", 100, 180, 150, 1, 1);
  delay(1000);
  mosaic(150,80,220,140, 10);
  delay(1500);

  viewpcx("flower.pcx");
  delay(1500);
  drawstr("Z O O M  X2", 100, 180, 150, 1,1);
  delay(1000);
  zoom2x(150,80,220,140,1,1);
  delay(1500);
  viewpcx("flower.pcx");
  drawstr("Z O O M  X2", 100, 180, 150, 1,1);
  delay(1000);
  zoom2x(220,30,300,90,1,1);

  delay(1500);
  viewpcx("flower.pcx");
  delay(1500);
  drawstr("GRAY SCALE", 100, 180, 150, 1,1);
  delay(1000);
  color2bw();

  viewpcx("flower.pcx");
  delay(1500);
  drawstr("B/W FILM", 100, 180, 150, 1,1);
  delay(1000);
  bwfilm();

  viewpcx("flower.pcx");
  delay(1500);
  drawstr("COLOR FILM", 100, 180, 150, 1,1);
  delay(1000);
  colorfilm();

  viewpcx("flower.pcx");
  delay(1500);
  drawstr("B/W EMPHASIZE", 100, 180, 150, 1, 1);
  delay(1000);
  emphasize_bw();

  viewpcx("flower.pcx");
  delay(1500);
  drawstr("COLOR EMPHASIZE", 100, 180, 150, 1,1);
  delay(1000);
  emphasize_color();

  viewpcx("flower.pcx");
  delay(1500);
  drawstr("4 GRAY SCALE", 100, 180, 150, 1,1);
  delay(1000);
  gray4scale_bw();

  viewpcx("flower.pcx");
  delay(1500);
  drawstr("4 COLOR SCALE", 100, 180, 150, 1,1);
  delay(1000);
  gray4scale_color();

  viewpcx("flower.pcx");
  delay(1500);
  drawstr("ROTATION", 120, 180, 150, 1,1);
  delay(1000);
  rotate(150,80,220,140, 150,100);
  pause(2);

  viewpcx("rose.pcx");
  delay(1000);
  drawstr("OUTLINE", 120, 180, 150, 1,1);
  delay(1500);
  findoutline();
  delay(1000);
  viewpcx("orchid.pcx");
  delay(1000);
  findoutline();
  delay(2000);

  viewpcx("orchid.pcx");
  delay(1000);
  drawstr("WOODCUT PRINT", 100, 180, 150, 1,1);
  delay(1500);
  woodcutprint();
  delay(2000);

  introstr("3D BASIC", 80, 80, 0);
  delay(1000);
  setrgb(15, 63, 63, 63);
  move3dbox();

  savergb();
  for (t=1; t<64; t++) setrgb(t, t, t, t);
  spacestar();
  restorergb();

  execl("real3d.exe",NULL);
}

void screenmode(int m)
{
  union REGS r;

  r.x.ax=m;
  int86(0x10,&r,&r);
}

void clearscreen(char rr)
{
  long far *v=(long far*)0xA0000000L;
  long t;

  for(t=0; t<16000; t++) {
	*v=0L;
	v++;
  }

  if (rr) restoreorgrgb();
}

void drawline(int x1, int y1, int x2, int y2, char col)
{
	float dy;
	int tmp, width;

	if (x1>x2) {
	  swap(x1,x2);
	  swap(y1,y2);
	}

	if (x1 == x2 && y1 == y2) {
	  putdot(x1,y1,col);
	  return;
	}

	if (x1 == x2) {
	  width=abs(y2-y1);
	  if (y2<y1) y1=y2;
	  for (tmp=0; tmp<=width; tmp++) putdot(x1, y1+tmp, col);
	  return;
	}

	if (y1 == y2) {
	  width=abs(x2-x1);
	  for (tmp=0; tmp<=width; tmp++) putdot(x1+tmp, y1, col);
	  return;
	}

	if (fabs((float)(y2-y1)/(float)(x2-x1)) < 1) {
		 dy=fabs((float)(y2-y1)/(float)(x2-x1));
		 width=abs(x2-x1);

		 if ((y2-y1) > 0) {
		   for (tmp=0; tmp<=width; tmp++)
		 putdot(tmp + x1, y1 + (int)((dy*tmp)+0.5),col);
		 } else
		   for (tmp=0; tmp<=width; tmp++)
		 putdot(tmp + x1, y1 - (int)((dy*tmp)+0.5),col);
	} else {
		 dy=fabs((float)(x2-x1)/(float)(y2-y1));
		 width=abs(y1-y2);

		 if ((y2-y1) > 0) {
		   for (tmp=0; tmp<=width; tmp++)
				putdot((int)((dy*tmp)+0.5) + x1, y1 + tmp, col);
		 } else
		 for (tmp=0; tmp<=width; tmp++)
			putdot((int)((dy*tmp)+0.5) + x1, y1 - tmp, col);
	}
}

void drawline2(int x1, int y1, int x2, int y2, char col, int del)
{
	float dy;
	int tmp, width;

	if (x1>x2) {
	  swap(x1,x2);
	  swap(y1,y2);
	}

	if (x1 == x2 && y1 == y2) {
	  putdot(x1,y1,col);
	  return;
	}

	if (x1 == x2) {
	  width=abs(y2-y1);
	  if (y2<y1) y1=y2;
	  for (tmp=0; tmp<=width; tmp++) {
	    delay(del);
	    putdot(x1, y1+tmp, col);
	  }
	  return;
	}

	if (y1 == y2) {
	  width=abs(x2-x1);
	  for (tmp=0; tmp<=width; tmp++) {
		delay(del);
	    putdot(x1+tmp, y1, col);
	  }
	  return;
	}

	if (fabs((float)(y2-y1)/(float)(x2-x1)) < 1) {
	     dy=fabs((float)(y2-y1)/(float)(x2-x1));
	     width=abs(x2-x1);

	     if ((y2-y1) > 0) {
	       for (tmp=0; tmp<=width; tmp++) {
		 delay(del);
		 putdot(tmp + x1, y1 + (int)((dy*tmp)+0.5),col);
	       }
	     } else
	       for (tmp=0; tmp<=width; tmp++) {
		 delay(del);
		 putdot(tmp + x1, y1 - (int)((dy*tmp)+0.5),col);
		   }
	} else {
	     dy=fabs((float)(x2-x1)/(float)(y2-y1));
	     width=abs(y1-y2);

	     if ((y2-y1) > 0) {
	       for (tmp=0; tmp<=width; tmp++) {
		  delay(del);
		  putdot((int)((dy*tmp)+0.5) + x1, y1 + tmp, col);
	       }
	     } else
		 for (tmp=0; tmp<=width; tmp++) {
		    delay(del);
		    putdot((int)((dy*tmp)+0.5) + x1, y1 - tmp, col);
		 }
	}
}

void angle2dconv(int ox, int oy, int *x, int *y, float a)
{
  a=M_PI/180*a;
  *x=(int)(ox*cos(a)-oy*sin(a));
  *y=(int)(ox*sin(a)+oy*cos(a));
}

void angle3dconv(int ox, int oy, int oz, int *x, int *y, int *z,
		 float a, float b, float c)
{
  angle2dconv(ox-axisx,oy-axisy,x,y,a);
  angle2dconv(oz-axisz,(int)*y,z,y,b);
  angle2dconv((int)*z,(int)*x,z,x,c);
}

void drawcircle(int x, int y, int r, char col)
{
  int startx, starty, endx, endy, t;

  startx=0;
  starty=r;

  for(t=10; t<=360; t+=10) {
	angle2dconv(0, r, &endx, &endy, t);
    drawline(startx+x+1, y-starty+1, endx+x+1, y-endy+1, col);
    startx=endx;
    starty=endy;
  }
}

void drawcircle2(int x, int y, int r, char col, int sval, int eval, char l, int del)
{
  int startx, starty, endx, endy, t;

  angle2dconv(0, r, &endx, &endy, sval*l);
  startx=endx;
  starty=endy;

  for(t=sval; t<=eval; t++) {
    delay(del);
    angle2dconv(0, r, &endx, &endy, l*t);
    drawline(startx+x+1, y-starty+1, endx+x+1, y-endy+1, col);
	startx=endx;
	starty=endy;
  }
}

void drawcircle3(int x, int y, int r, char col, int sval, int ang, char l)
{
  int startx, starty, endx, endy, t;

  angle2dconv(0, r, &endx, &endy, sval*l);
  startx=endx;
  starty=endy;

  for(t=sval; t<=(360+sval); t+=ang) {
    angle2dconv(0, r, &endx, &endy, t*l);
    drawline(startx+x+1, y-starty+1, endx+x+1, y-endy+1, col);
    startx=endx;
    starty=endy;
  }
}

void drawcaerang()
{
   drawcircle2(70,60,45,15,-20,200,1, 10);
   delay(500);

   sparkeffect();
   drawline2(100, 105, 120, 55, 15, 0);
   delay(100);
   sparkeffect();
   drawline2(120, 55, 140, 105, 15, 0);
   delay(100);
   sparkeffect();
   drawline2(108, 90, 132, 90, 15, 0);
   delay(500);

   sparkeffect();
   drawline2(150, 55, 180, 55, 15, 10);
   sparkeffect();
   drawline2(150, 105, 180, 105, 15, 10);
   sparkeffect();
   drawline2(150, 55, 150, 105, 15, 10);
   sparkeffect();
   drawline2(150, 80, 180, 80, 15, 10);
   delay(500);

   drawline2(70, 120, 70, 170, 9, 10);
   delay(200);
   drawcircle2(75,130,15,9,-22,190, -1, 10);
   drawline2(70, 145, 100, 170, 9, 0);
   delay(500);

   sparkeffect();
   drawline2(115, 170, 135, 120, 9, 0);
   sparkeffect();
   drawline2(135, 120, 155, 170, 9, 0);
   sparkeffect();
   drawline2(123, 149, 147, 149, 9, 0);
   delay(500);

   sparkeffect();
   drawline2(165, 120, 165, 170, 9, 0);
   sparkeffect();
   drawline2(165, 120, 195, 170, 9, 0);
   sparkeffect();
   drawline2(195, 120, 195, 170, 9, 0);
   delay(500);

   drawcircle2(230, 145, 25, 9, -40, 210, 1, 10);
   sparkeffect();
   drawline2(230, 145, 250, 145, 9, 0);
   sparkeffect();
   drawline2(243, 145, 243, 170, 9, 0);
}

void sparkeffect()
{
  int t, i;

  for (t=0; t<256; t++)
	getrgb(t, &RGB[t][0], &RGB[t][1], &RGB[t][2]);

  for (t=0; t<256; t++)
	setrgb(t, 63, 63, 63);

  delay(20);

  for (t=0; t<256; t++)
	setrgb(t, 0, 0, 0);

  for (t=0; t<256; t++)
	setrgb(t, RGB[t][0], RGB[t][1], RGB[t][2]);
}

long al_et;

int alarm(int sec)
{
  long far *tick=(long far *)0x0040006c;

  if (sec != 0) {
	al_et=*tick+(int)(float)(18.2*sec);
	return 0;
  }

  if (al_et <= *tick) return 1;
  else return 0;
}

#define MAX_SNOW 100

class vsnow {
  public:
		int x,y,sx,sy;
		char color;
		char candraw;
		virtual void drawsnow();
		virtual void undrawsnow();
		virtual void process();
};

class bigsnow: public vsnow {
  public:
		 void drawsnow();
		 void undrawsnow();
		 void process();
};

void snowfalls()
{
   vsnow *snow[MAX_SNOW];
   bigsnow *bsnow[MAX_SNOW];

   int t;

   randomize();

   // initialize the snow variable
   for (t=0;t<MAX_SNOW;t++) {
	 snow[t]=new vsnow;
	 snow[t]->x=random(320);
	 snow[t]->y=random(200);
	 snow[t]->color=7;

	 bsnow[t]=new bigsnow;
	 bsnow[t]->x=random(320);
	 bsnow[t]->y=random(200);
	 bsnow[t]->color=15;
   }

   alarm(10);
   while (!alarm(0)) {
	 for (t=0;t<MAX_SNOW;t++) {
	   snow[t]->drawsnow();
	   bsnow[t]->drawsnow();
	 }

	 delay(20);

	 for (t=0;t<MAX_SNOW;t++) {
	   snow[t]->process();
	   snow[t]->undrawsnow();
	   bsnow[t]->process();
	   bsnow[t]->undrawsnow();
	 }
   }

   for (t=0;t<MAX_SNOW;t++) {
	 delete snow[t];
	 delete bsnow[t];
   }
}

void vsnow::drawsnow()
{
  putdot(x,y,color);
}

void vsnow::undrawsnow()
{
  putdot(sx,sy,0);
}

void vsnow::process()
{
   sx=x;
   sy=y;

   if (random(6)==0)
	 if (x>0) x--;
	 else x=319;

   if (random(2)==0)
	 if (x<320) x++;
	 else x=0;

   if (y<200) y++;
   else y=0;
}

void bigsnow::drawsnow()
{
  putdot(x,y,color);
  putdot(x+1,y,color);
  putdot(x,y+1,color);
}

void bigsnow::undrawsnow()
{
  putdot(sx,sy,0);
  putdot(sx+1,sy,0);
  putdot(sx,sy+1,0);
}

void bigsnow::process()
{
   sx=x;
   sy=y;

   if (random(6)==0)
	 if (x>0) x-=1;
	 else x=319;

   if (random(2)==0)
	 if (x<320) x+=1;
	 else x=0;

   if (y<200) y+=2;
   else y=0;

   if (random(5)==0) y-=2;
}

void gettextfont(byte code, char *table)
{
  int t;

  outport(0x3c4, 0x0704);
  outport(0x3ce, 0x0204);
  outport(0x3ce, 0x0005);
  outport(0x3ce, 0x0406);

  for (t=0; t<16; t++)
	table[t]=peekb(0xA000, (code<<5)+t);

//  movedata(0xA000, code<<5, FP_SEG(*table), (unsigned)table, 16);
  outport(0x3c4, 0x0304);
  outport(0x3ce, 0x0004);
  outport(0x3ce, 0x1005);
  outport(0x3ce, 0x0e06);
}

void settextfont(byte code, char *table)
{
  int t;

  outport(0x3c4, 0x0402);
  outport(0x3c4, 0x0704);
  outport(0x3ce, 0x0005);
  outport(0x3ce, 0x0406);

  for (t=0; t<16; t++)
	pokeb(0xA000, (code <<5)+t, table[t]);

//  movedata(FP_SEG(table), (unsigned)table, 0xA000, code<<5, 16);
  outport(0x3c4, 0x0302);
  outport(0x3c4, 0x0304);
  outport(0x3ce, 0x1005);
  outport(0x3ce, 0x0e06);
}

long filesize(FILE *stream)
{
   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);
   return length;
}

void color2bw()
{
  byte r, g, b;
  int t;

  savergb();

  for (t=0; t<256; t++) {
	 getrgb(t, &r, &g, &b);
	 r=((r+g+b)/3);
	 setrgb(t, r, r, r);
  }

  pause(3);

  restorergb();
}

void bwfilm()
{
  byte r,g,b;
  int t;

  savergb();

  for (t=0; t<256; t++) {
	 getrgb(t, &r, &g, &b);
	 r=63-((r+g+b)/3);
	 setrgb(t, r,r,r);
  }

  pause(3);

  restorergb();
}

void colorfilm()
{
  byte r,g,b;
  int t;

  savergb();

  for (t=0; t<256; t++) {
	 getrgb(t, &r, &g, &b);
	 r=63-r;
	 g=63-g;
	 b=63-b;
	 setrgb(t, r,g,b);
  }

  pause(3);

  restorergb();
}

void emphasize_bw()
{
  byte r,g,b;
  int t;

  savergb();

  for (t=0; t<256; t++) {
	 getrgb(t, &r, &g, &b);
	 if ((r+g+b) < 65) setrgb(t, 0,0,0);
	 else setrgb(t, 48, 48, 48);
  }

  pause(3);

  restorergb();
}

void emphasize_color()
{
  byte r,g,b;
  int t;

  savergb();

  for (t=0; t<256; t++) {
	 getrgb(t, &r, &g, &b);
	 if (r<35) r=0; else r=63;
	 if (g<35) g=0; else g=63;
	 if (b<35) b=0; else b=63;

	 setrgb(t, r, g, b);
  }

  pause(3);

  restorergb();
}

void gray4scale_bw()
{
  byte r,g,b;
  int t;

  savergb();

  for (t=0; t<256; t++) {
	 getrgb(t, &r, &g, &b);
	 r=(r+g+b)/(3*16)*16;
	 setrgb(t, r, r, r);
  }

  pause(3);

  restorergb();
}

void gray4scale_color()
{
  byte r,g,b;
  int t;

  savergb();

  for (t=0; t<256; t++) {
	 getrgb(t, &r, &g, &b);
	 r=r/16*16;
	 g=g/16*16;
	 b=b/16*16;
	 setrgb(t, r, g, b);
  }

  pause(3);

  restorergb();
}

void fallingdots(int del)
{
  int X,Y,OX,OY,PX,PY;
  byte C;

  for (PY=200; PY>0; PY--)
	for (PX=320; PX>0; PX--)
	  if ((C=getdot(PX, PY)) != 0) {
		X=PX;
		Y=PY;

		while (1) {
		  delay(del);
		  OX=X;
		  OY=Y;

		  if (Y==201) break;

		  if (getdot(X,Y+1) == 0) Y++;
		  else if (getdot(X-1,Y+1) == 0) X--;
		  else if (getdot(X+1,Y+1) == 0) X++;
		  else break;
		  if (X<1 || X>320) break;

		  putdot(X,Y,C);
		  putdot(OX,OY,0);
		}
	  }

}

void polygon1()
{
  int t, i, AMAX;

  AMAX=200;
  for(i=0; i<AMAX; i++) {
	for(t=0; t<=100; t+=10)
	  if (i % 2==0) drawcircle3(150,100,t,(t % 63)+1, i % AMAX, 60,1);
	  else drawcircle3(150,100,t,(t % 63)+1, AMAX - (i % AMAX), 60,1);

	delay(5);

	for(t=0; t<=100; t+=10)
	  if (i % 2==0) drawcircle3(150,100,t,0, i % AMAX, 60,1);
	  else drawcircle3(150,100,t,0, AMAX - (i % AMAX), 60,1);
  }
}

void polygon2()
{
  int t, i, AMAX;

  AMAX=360;
  for(i=0; i<AMAX; i++) {
	for(t=0; t<=100; t+=10)
	  if (t/10 % 2==0) drawcircle3(150,100,t,(t % 63)+1, i, 60, 1);
	  else drawcircle3(150,100,t,(t % 63)+1, i, 60, -1);

	rotatergb(1,63);
	delay(5);

	for(t=0; t<=100; t+=10)
	  if (t/10 % 2==0) drawcircle3(150,100,t,0, i, 60, 1);
	  else drawcircle3(150,100,t,0, i, 60, -1);
  }
}

void cut4times()
{
  int y=1, x=1, t;

  for (t=0; t<4; t++) {
	sparkeffect();

	for (y=1; y<=200; y++) {
	  //delay(1);
	  drawline(x+(t*80), y, x+((t+1)*80), y, 0);
	}

	delay(300);
  }
}

void WVirt()
{
	  asm  mov   dx,   3dah
wvloop:
	  asm  in    al,   dx
	  asm  test  al,   08h
	  asm  jz    wvloop
}

void drawbox(int l, int t, int r, int b, char col)
{
  drawline2(l,t,r,t,col, 0);
  drawline2(l,b,r,b,col, 0);
  drawline2(l,t+1,l,b-1,col, 0);
  drawline2(r,t+1,r,b-1,col, 0);
}

void zoom2x(int x1, int y1, int x2, int y2, int dx, int dy)
{
  byte width=abs(x2-x1);
  byte depth=abs(y2-y1);
  int t,i, nowy, nowx;

  char *buf=(char *) malloc(width*depth);
  char *sbuf;

  sbuf=buf;

  drawbox(x1-1,y1-1,x2+1,y2+1,0);

  for (t=0; t<3; t++) {
	drawbox(x1-1,y1-1,x2+1,y2+1,200);
	delay(100);
	drawbox(x1-1,y1-1,x2+1,y2+1,0);
	delay(100);
  }

  delay(500);

  for (t=0; t<depth; t++)
	for (i=0; i<width; i++)
	  *buf++ = getdot(x1+i, y1+t);

  nowy=0;
  nowx=0;

  for (t=0; t<depth; t++) {
	for (i=0; i<width; i++) {
	  putdot(dx+nowx, dy+nowy, *sbuf);
	  putdot(dx+nowx+1, dy+nowy, *sbuf);
	  putdot(dx+nowx, dy+nowy+1, *sbuf);
	  putdot(dx+nowx+1, dy+nowy+1, *sbuf);
	  nowx+=2;
	  sbuf++;
	}

	nowx=0;
	nowy+=2;
  }

  free(buf);
}

void drawstr(char *str, int x, int y, char col, char zx, char zy)
{
  int t,i, c=0;
  int N;

  while(*str) {
	for (t=0; t<16; t++) {
	  N=128;

	  for (i=0; i<8; i++) {
	if (FONT[*str][t] == 0) break;

	if ((FONT[*str][t] & N) != 0)
	   putdot(x+(i*zx)+(c*9*zx), y+t*zy,col);

	N /= 2;
	  }
	}

	c++;
	str++;
  }
}

void drawstr2(char *str, int x, int y, char col)
{
  int t,i, c=0;
  int N;
  float a=0.0;

  while(*str) {
	for (t=0; t<16; t++) {
	  N=128;

	  for (i=0; i<8; i++) {
	a++;

	if (FONT[*str][t] == 0) break;

	if ((FONT[*str][t] & N) != 0)
	   putdot(x+(i*2)+(c*9*2), y+t*3+(int)(5*sin(M_PI/180*a)),col);

	N /= 2;
	  }
	}

	c++;
	str++;
  }
}

void NewWriterInit()
{
  int t;

  for (t=0; t<256; t++) gettextfont(t,FONT[t]);
}

void introstr(char *str, int x, int y, char l)
{
  int t, i;

  savergb();

  for (t=1; t<256; t++) setrgb(t, 0, 0, 0);

  if (l==0) drawstr(str, x, y, 15, 2, 3);
  else drawstr2(str, x, y, 15);

  for (i=0; i<64; i++) {
	delay(30);
	for (t=1; t<256; t++) setrgb(t, i, i, i);
  }

  delay(2000);

  for (i=63; i>-1; i--) {
	delay(20);
	for (t=1; t<256; t++) setrgb(t, i, i, i);
  }

  delay(500);
  clearscreen(0);

  restorergb();
}

void pause(int sec)
{
  alarm(sec);
  while(!alarm(0));
}

void pause2(int sec)
{
  alarm(sec);
  while(!alarm(0)) {
	rotatergb(1,63);
	delay(10);
  }
}

void MakeSame(Box3DType *src, Box3DType *dest)
{
  int t;

  for (t=0; t<8; t++) {
	dest->a[t][0] = src->a[t][0];
	dest->a[t][1] = src->a[t][1];
	dest->a[t][2] = src->a[t][2];
  }

  //movedata(_DS,(unsigned)src,_DS,(unsigned)dest,sizeof(Box3DType));
}

void perspective(Box3DType *o)
{
  int t;
  float tr;

  for (t=0; t<8; t++) {
	tr=(1+(float)o->a[t][2]/300);
	o->a[t][0]=(int)(o->a[t][0]*tr);
	o->a[t][1]=(int)(o->a[t][1]*tr);
	o->a[t][2]=(int)(o->a[t][2]*tr);
  }
}

void Draw3dbox()
{
  char t;
  char col;
  Box3DType B;

  for (t=0; t<2; t++) {
	WVirt();

	if (t==0) {
	  col=15;
	  MakeSame(&Box3D,&B);
	} else {
	  col=0;
	  MakeSame(&BoxC,&B);
	}

	perspective(&B);

	drawline(B.a[0][0]+ViewX,B.a[0][1]+ViewY,B.a[1][0]+ViewX,B.a[1][1]+ViewY, col);
	drawline(B.a[0][0]+ViewX,B.a[0][1]+ViewY,B.a[2][0]+ViewX,B.a[2][1]+ViewY, col);
	drawline(B.a[1][0]+ViewX,B.a[1][1]+ViewY,B.a[3][0]+ViewX,B.a[3][1]+ViewY, col);
	drawline(B.a[2][0]+ViewX,B.a[2][1]+ViewY,B.a[3][0]+ViewX,B.a[3][1]+ViewY, col);

	drawline(B.a[4][0]+ViewX,B.a[4][1]+ViewY,B.a[5][0]+ViewX,B.a[5][1]+ViewY, col);
	drawline(B.a[4][0]+ViewX,B.a[4][1]+ViewY,B.a[6][0]+ViewX,B.a[6][1]+ViewY, col);
	drawline(B.a[5][0]+ViewX,B.a[5][1]+ViewY,B.a[7][0]+ViewX,B.a[7][1]+ViewY, col);
	drawline(B.a[6][0]+ViewX,B.a[6][1]+ViewY,B.a[7][0]+ViewX,B.a[7][1]+ViewY, col);

	drawline(B.a[4][0]+ViewX,B.a[4][1]+ViewY,B.a[0][0]+ViewX,B.a[0][1]+ViewY, col);
	drawline(B.a[5][0]+ViewX,B.a[5][1]+ViewY,B.a[1][0]+ViewX,B.a[1][1]+ViewY, col);
	drawline(B.a[6][0]+ViewX,B.a[6][1]+ViewY,B.a[2][0]+ViewX,B.a[2][1]+ViewY, col);
	drawline(B.a[3][0]+ViewX,B.a[3][1]+ViewY,B.a[7][0]+ViewX,B.a[7][1]+ViewY, col);
  } // end of if
}

void move3dbox()
{
  float a,b,c;
  int t;

  Org3D.a[0][0]=10;  Org3D.a[0][1]=50; Org3D.a[0][2]=10;
  Org3D.a[1][0]=90;  Org3D.a[1][1]=50; Org3D.a[1][2]=10;
  Org3D.a[2][0]=10;  Org3D.a[2][1]=70; Org3D.a[2][2]=10;
  Org3D.a[3][0]=90;  Org3D.a[3][1]=70; Org3D.a[3][2]=10;
  Org3D.a[4][0]=10;  Org3D.a[4][1]=50; Org3D.a[4][2]=20;
  Org3D.a[5][0]=90;  Org3D.a[5][1]=50; Org3D.a[5][2]=20;
  Org3D.a[6][0]=10;  Org3D.a[6][1]=70; Org3D.a[6][2]=20;
  Org3D.a[7][0]=90;  Org3D.a[7][1]=70; Org3D.a[7][2]=20;

  MakeSame(&Org3D,&Box3D);
  a=0;
  b=0;
  c=0;

  alarm(15);
  do {
	MakeSame(&Box3D,&BoxC);

	if (Zoom < 2.0) Zoom+=0.01; else Zoom=2.0;

	for (t=0; t<8; t++)
	  angle3dconv(Org3D.a[t][0]*Zoom,Org3D.a[t][1]*Zoom,Org3D.a[t][2]*Zoom,
		  &Box3D.a[t][0],&Box3D.a[t][1],&Box3D.a[t][2],a,b,c);

	a+=1;
	b+=1;
	c+=2;

	Draw3dbox();
  } while (!alarm(0));

  clearscreen(0);
}

void rotate(int x1, int y1, int x2, int y2, int dx, int dy)
{
  byte width=abs(x2-x1);
  byte depth=abs(y2-y1);
  int t,i, nowy, nowx, cenx, ceny, ang;
  float a;

  char *buf=(char *)malloc(width*depth);
  char *wbuf;

  wbuf=buf;

  drawbox(x1-1,y1-1,x2+1,y2+1,0);

  for (t=0; t<3; t++) {
	drawbox(x1-1,y1-1,x2+1,y2+1,200);
	delay(100);
	drawbox(x1-1,y1-1,x2+1,y2+1,0);
	delay(100);
  }

  cenx=width/2;
  ceny=depth/2;

  delay(500);

  for (t=0; t<depth; t++)
	for (i=0; i<width; i++)
	  *wbuf++ = getdot(x1+i, y1+t);

  wbuf=buf;

  for (ang=0; ang<=90; ang+=3) {
	video(1);
	clearscreen(0);
	wbuf=buf;

	for (t=0; t<depth; t++)
	  for (i=0; i<width; i++) {
		a=M_PI/180*ang;
		nowx=(int)((i-cenx)*cos(a)-(t-ceny)*sin(a));
		nowy=(int)((i-cenx)*sin(a)+(t-ceny)*cos(a));
		putdot(dx+nowx, dy+nowy, *wbuf);
		wbuf++;
	  }

	video(0);
    delay(100);
  }

  free(buf);
}

void verticalwave()
{
  int t, x1, x2, i;

  savergb();
  for (t=1; t<32; t++) setrgb(t, t, t, t);
  for (t=1; t<31; t++) setrgb(t+31, 31-t, 31-t, 31-t);

  alarm(7);
  x1=0;
  while(!alarm(0)) {
	for (t=1; t<=200; t++) {
	  for (i=120; i<180; i++) {
		x2=(int)(5*sin(M_PI/180*(x1 % 360)));
		putdot(i+x2, t, ((i-119)%63)+1);
	  }
	  x1+=5;
	}
  }

  delay(2000);
  clearscreen(0);
  restorergb();
}

void fallchar(char *c, int x, char col)
{
  int t, y=1;
  float f=0;

  drawstr(c, x, y, col, 3, 5);
  delay(300);

  for (t=1; t<70; t++) {
    f+=0.05;
    y+=(int)f;

	drawstr(c, x, y, col, 3, 5);
    delay(5);
    drawstr(c, x, y, 0, 3, 5);
  }

  drawstr(c, x, y, col, 3, 5);
}

void lastcaerang()
{
  int t;

  fallchar("C", 20, 15); delay(500);
  fallchar("A", 80, 12); delay(500);
  fallchar("E", 110, 12); delay(500);
  fallchar("R", 170, 13); delay(500);
  fallchar("A", 200, 13); delay(500);
  fallchar("N", 230, 13); delay(500);
  fallchar("G", 260, 13); delay(500);

  fallchar("\007", 50, 9); delay(500);
  fallchar("\007", 140, 9); delay(500);


  randomize();

  alarm(12);

  while(!alarm(0)) {
    t=random(7);

    switch(t) {
      case 0: fallchar("C", 20, random(15)+1); break;
      case 1: fallchar("A", 80, random(15)+1); break;
	  case 2: fallchar("E", 110, random(15)+1); break;
      case 3: fallchar("R", 170, random(15)+1); break;
	  case 4: fallchar("A", 200, random(15)+1); break;
      case 5: fallchar("N", 230, random(15)+1); break;
      case 6: fallchar("G", 260, random(15)+1); break;
    }
  }

  fadeout();
}

void noize()
{
  int t;

  screenmode(0x03);

  cursor(0);

  for (t=0; t<16; t++) FONT[219][t] = random(256);
  settextfont(219, FONT[219]);

  for (t=0; t<2000; t++) *((unsigned far *)0xb8000000L + t) = 2011;
  puttextchar(32, 11, 'C', 15);
  puttextchar(36, 11, 'A', 15);
  puttextchar(38, 11, 'E', 15);
  puttextchar(42, 11, 'R', 15);
  puttextchar(44, 11, 'A', 15);
  puttextchar(46, 11, 'N', 15);
  puttextchar(48, 11, 'G', 15);

  puttextchar(36, 13, 'n', 12);
  puttextchar(38, 13, 'o', 12);
  puttextchar(40, 13, 'i', 12);
  puttextchar(42, 13, 's', 12);
  puttextchar(44, 13, 'e', 12);


  alarm(5);

  while(!alarm(0)) {
    for (t=0; t<16; t++) FONT[219][t] = random(256);
	settextfont(219, FONT[219]);
  }

  screenmode(0x13);
}

void fadeout()
{
  int t, i;

  savergb();
  for (t=63; t>-1; t--) {
	for (i=0; i<256; i++) setrgb(i, t, t, t);
	delay(30);
  }
  clearscreen(0);
  restorergb();
}

void findoutline()
{
  int x,y;
  char cdot, ldot;

  savergb();

  for (x=1; x<=320; x++) {
	for (y=1; y<=200; y++)
	  if (getrgbavr(x,y) > 15) putdot(x, y, 1);
	  else putdot(x, y, 2);
  }

  setrgb(1, 63, 63, 63);

  for (x=1; x<=320; x++) {
	for (y=1; y<=200; y++) {
	  cdot=getdot(x,y);

	  if (ldot != cdot) {
		putdot(x,y,1);
	  } else putdot(x,y,0);

	  ldot=cdot;
	}
  }

  pause(5);
  clearscreen(0);
  restorergb();
}


char getrgbavr(int x, int y)
{
  byte r,g,b;

  getrgb(getdot(x,y), &r, &g, &b);

  return((r+g+b)/3);
}

void woodcutprint()
{
  int x,y;
  char cdot, ldot, col = 2;

  savergb();

  for (x=1; x<=320; x++) {
	for (y=1; y<=200; y++)
	  if (getrgbavr(x,y) > 15) putdot(x, y, 2);
	  else putdot(x, y, 3);
  }

  setrgb(1, 35, 35, 35);
  setrgb(2, 25, 25, 25);
  setrgb(3, 15, 15, 15);
  setrgb(4, 5, 5, 5);

  for (x=1; x<=320; x++) {
	for (y=1; y<=200; y++) {
	  cdot=getdot(x,y);

	  if (ldot != cdot) {
		if (getrgbavr(x,y-1) > getrgbavr(x,y)) putdot(x,y,4);
		else putdot(x,y,1);

		if (col==2) col=3;
		else col=2;

	  } else putdot(x,y,col);

	  ldot=cdot;
	}
  }

  pause(5);
  clearscreen(0);
  restorergb();
}

void plasma()
{
  byte r,g,b, sr, sg, sb;
  int i;

  savergb();

  alarm(10);
  while(!alarm(0)) {
	  getrgb(255, &sr, &sg, &sb);
	  for (i=255; i>1; i--) {
		getrgb(i-1, &r, &g, &b);
		setrgb(i, r, g, b);
	  }
	  setrgb(1, sr, sg, sb);

	  delay(10);
  }

  restorergb();
}

void undefinable()
{
  int x, y;
  int cenx, ceny;
  byte r,g,b;
  char dot;

  cenx=160;
  ceny=100;

  for (x=1; x<=320; x++)
	for (y=1; y<=200; y++) {
		dot=(int)(exp((x-cenx)*(y-ceny) / 1000));
		putdot(x,y, dot);
	}

  delay(2000);
  clearscreen(0);

  for (x=1; x<=320; x++)
	for (y=1; y<=200; y++) {
		dot=(int)(exp(((x-cenx)*(x-cenx)+(y-ceny)*(y-ceny)) / 1000));
		putdot(x,y+dot, dot);
	}

  delay(2000);
  clearscreen(0);

  for (x=1; x<=320; x++)
	for (y=1; y<=200; y++) {
		dot=(int)(exp(((x-cenx)*(y-ceny)*(x-ceny)) / 1000));
		putdot(x,y, dot);
	}

  delay(2000);
}

void putstr(byte *str, char x, char y, char col, char cen)
{
  char t;
  char len=strlen(str);

  if (cen) x=(80-len)/2;

  for (t=0; t<80; t++) puttextchar(t, y, ' ', 7);

  for (t=0; t<len; t++)
	puttextchar(x+t, y, *(str+t), col);
}

void clear4textpage()
{
  char x,y;

  for (x=1; x<=80; x++)
	for (y=1; y<=125; y++) puttextchar(x, y, ' ', 7);
}

void scrolluptext()
{
  int t;

  clear4textpage();

  cursor(0);

  putstr("         CODE         ", 1, 26, 15, 1);
  putstr("KIM, JIN HONG", 1, 28, 7,1);
  putstr("5th C.AE.RANG MEMBER", 1, 29, 7, 1);
  putstr(" GRAPHIC DATA SUPPORT ", 1, 33, 15,1);
  putstr("KIM, GYU HAN", 1, 35, 7,1);
  putstr("4th C.AE.RANG MEMBER", 1, 36, 7, 1);
  putstr("      POSTSCRIPT      ", 1, 40, 15, 1);
  putstr("C.AE.RANG is a learning group with passion", 1, 42, 7, 1);
  putstr("Why don't you research together?", 1, 43, 7, 1);
  putstr("Thanks to all the C.AE.RANG members!", 1, 46, 9, 1);

  putstr(" SOME TECHNICAL CODES ", 1, 50, 15, 1);
  putstr("if (fabs((float)(y2-y1)/(float)(x2-x1)) < 1) {", 20, 52, 7, 0);
  putstr("  dy=fabs((float)(y2-y1)/(float)(x2-x1));", 20, 53, 7, 0);
  putstr("  width=abs(x2-x1);", 20, 54, 7, 0);
  putstr("  if ((y2-y1) > 0) {", 20, 56, 7, 0);
  putstr("     for (tmp=0; tmp<=width; tmp++)", 20, 57, 7, 0);
  putstr("        putdot(tmp + x1, y1 + (int)((dy*tmp)+0.5),col);", 20, 58, 7, 0);
  putstr("  } else", 20, 59, 7, 0);
  putstr("     for (tmp=0; tmp<=width; tmp++)", 20, 60, 7, 0);
  putstr("        putdot(tmp + x1, y1 - (int)((dy*tmp)+0.5),col);", 20, 61, 7, 0);
  putstr("  } else {", 20, 62, 7, 0);
  putstr("...", 20, 64, 7, 0);
  putstr("void perspective(Box3DType *o)",20, 66, 7, 0);
  putstr("{",20, 67, 7, 0);
  putstr("  int t;",20, 68, 7, 0);
  putstr("  float tr;",20, 69, 7, 0);
  putstr("  for (t=0; t<8; t++) {",20, 70, 7, 0);
  putstr("    tr=(1+(float)o->a[t][2]/300);",20, 71, 7, 0);
  putstr("    o->a[t][0]=(int)(o->a[t][0]*tr);",20, 72, 7, 0);
  putstr("    o->a[t][1]=(int)(o->a[t][1]*tr);",20, 73, 7, 0);
  putstr("    o->a[t][2]=(int)(o->a[t][2]*tr);",20, 74, 7, 0);
  putstr("  }",20, 75, 7, 0);
  putstr("}",20, 76, 7, 0);
  putstr("ALL DONE", 1, 85, 14, 1);

  for (t=0; t<16*89; t++) {
	set_a(-1, t);
	delay(30);
  }

  set_a(-1, 0);
}


#define SUCCESS 1
#define FAIL    0

int set_a(int x,int y)
	/* x : x coordinate of new origin */
	/* y : y coordinate of new origin */
	/* returns a flag whether succeeded */
	/* only for EGA/VGA alphanumeric modes */
	/* This program assumes 8 dots per character alphanumeric mode. */
{
	union REGS regs;
	int vmode,points,columns,addr,xboffset,yboffset;
	unsigned int offset;

	vmode = peekb(0x0040,0x0049);
	points = peekb(0x0040,0x0085);
	if (!(((vmode >= 0) && (vmode <= 3)) || (vmode == 7)))
	  return(FAIL);

	if ((vmode == 0) || (vmode == 1)) columns = 40;
	else columns = 80;
	offset = columns * (y / points) + (x / 8);
	xboffset = x % 8; yboffset = y % points;

	/* set CRT Controller Start Address registers */
	addr = peek(0x0040,0x0063);
	outportb(addr,0x0c);
	outportb(addr + 1,offset / 0x100);
	outportb(addr,0x0d);
	outportb(addr + 1,offset % 0x100);
	poke(0x0040,0x004e,offset);

	/* set CRT Controller Preset Row Scan register */
	WVirt();
	outportb(addr,0x08);
	outportb(addr + 1,yboffset);

	/* set Attribute Controller Horizontal Pixel Panning register */
	regs.h.ah = 0x10;
	regs.h.al = 0x00;
	regs.h.bh = xboffset;
	regs.h.bl = 0x13;
	int86(0x10,&regs,&regs);

	return(SUCCESS);
}

void cursor(char nf)
{
  if (nf) asm {
	mov  ah,01
	mov  ch,06
	mov  cl,07
	int  10h
  } else asm {
	mov ah,01
	mov ch,0fh
	mov cl,0
	int 10h
  }
}

void blinkattr(char bool)
{
   asm mov ah, 10h
   asm mov al, 3
   if (bool) asm mov bl, 1
   else asm mov bl, 0;
   asm int 10h
}

void electricworm()
{
  int x=79, y=49;
  int dx, dy;
  char col=15;

  randomize();

  dx=dy=1;
  alarm(10);
  while(!alarm(0)) {
	if (!random(5)) dx = (random(2)) ? 1:-1;
	if (!random(5)) dy = (random(2)) ? 1:-1;

	x += dx;
	y += dy;

	if (x<0 || x>319) {
	  dx=-dx;
	  if (x<0) x=0;
	  if (x>159) x=159;
	} else
	   if (y<0 || y>99) {
		 dy=-dy;
		 if (y<0) y=0;
		 if (y>99) y=99;
	   }

	if (!random(10)) col=random(14)+1;

	putdot2(x, y, col);
	putdot2(159+(159-x), y, col);
	putdot2(x, 99+(99-y), col);
	putdot2(159+(159-x), 99+(99-y), col);
	delay(5);
  }

  delay(2000);
}

void mosaic(int x1, int y1, int x2, int y2, char val)
{
  byte width=abs(x2-x1);
  byte depth=abs(y2-y1);
  int t,i, nowy, nowx, loopx, loopy;

  char *buf=(char *)malloc(width*depth);
  char *sbuf;

  sbuf=buf;

  drawbox(x1-1,y1-1,x2+1,y2+1,0);

  for (t=0; t<3; t++) {
	drawbox(x1-1,y1-1,x2+1,y2+1,200);
	delay(100);
	drawbox(x1-1,y1-1,x2+1,y2+1,0);
	delay(100);
  }

  delay(500);

  for (t=0; t<depth; t++)
	for (i=0; i<width; i++)
	  *buf++ = getdot(x1+i, y1+t);

  nowy=0;
  nowx=0;

  for (t=0; t<depth/val; t++) {
	for (i=0; i<width/val; i++) {
	  for (loopy=0; loopy<val; loopy++)
		for (loopx=0; loopx<val; loopx++)
		  putdot(x1+nowx+loopx, y1+nowy+loopy, *sbuf);

	  nowx+=val;
	  sbuf+=val;
	}

	nowx=0;
	nowy+=val;
	sbuf+=width;
  }

  free(buf);
}

#define MAX_STAR 150

struct {
  int x,y,z;
  char col;
} star[MAX_STAR], wstar[MAX_STAR];

void perspective_star()
{
  int t;
  float tr;

  for (t=0; t<MAX_STAR; t++) {
	tr=(1+(float)star[t].z/60);
	wstar[t].x=(int)((star[t].x-30)*tr);
	wstar[t].y=(int)((star[t].y-30)*tr);
	wstar[t].z=(int)((star[t].z)*tr);
  }
}

void drawstar(char b)
{
  int t;
  char col;

  for (t=0; t<MAX_STAR; t++) {
	if (!b) col=0;
	else col=(int)(star[t].z * 30 /300)+30;

	if (wstar[t].x > -150 && wstar[t].x < 150 &&
		wstar[t].y > -100 && wstar[t].y < 100)
		  putdot(150+wstar[t].x, 100+wstar[t].y, col);
  }
}

void spacestar()
{
  int t;

  randomize();
  for (t=0; t<MAX_STAR; t++) {
	wstar[t].x=star[t].x=random(60);
	wstar[t].y=star[t].y=random(60);
	wstar[t].z=star[t].z=random(300)+1;
  }

  alarm(10);
  while(!alarm(0)) {
	 for (t=0; t<MAX_STAR; t++)
	   if (star[t].z < 300) star[t].z+=3; else star[t].z=1;

	 perspective_star();

	 drawstar(1);
	 delay(15);
	 drawstar(0);
  }
}
